<?php
/***************************
*    COPYRIGHT NOTICE
* This software is produced by
* Alex Reinhart and is licenced 
* under the GNU General Public License. 
* There is no warranty whatsoever,
* and the creators are not responsible
* for damages to your system caused
* by this product.
* A copy of the General Public License
* is included in every download of this
* software, as LICENCE.txt. If you did 
* not receive a copy of the licence, 
* you may find it online.
***************************/

error_reporting(E_ALL);
$pathdot = '..';
require_once "{$pathdot}/includes/common.php";
$user = new User;
if((!$user->logincheck(&$database)) || ($user->can_admin_panel === FALSE))
{
	header('Location: admin_login.php');
}

$action = isset($_GET['action']) ? $_GET['action'] : 'select';

require_once '../includes/Smarty.class.php';
$template = new Smarty;

$template->template_dir = './template';
$template->compile_dir = './template/compiled';

require_once './sidebar.php';

$template->assign('LANGPERMISSIONS', $lang['permissions']);
$template->assign('TITLE', $lang['permissions']);
$template->assign('LANGSUBMIT', $lang['submit']);
switch($action)
{
case 'change':
	$group = $_GET['group'];
	$database->query("SELECT `group_name`, `user_permissions`, `user_rank` FROM `permissions` WHERE `user_rank` = '{$group}'");
	$group = $database->fetch_assoc($database->result);
	$can_view = (($group['user_permissions'] & 1) == 1);
	$can_edit = (($group['user_permissions'] & 2) == 2);
	$can_create = (($group['user_permissions'] & 4) == 4);
	$can_redirect = (($group['user_permissions'] & 8) == 8);
	$can_protect = (($group['user_permissions'] & 16) == 16);
	$can_delete = (($group['user_permissions'] & 32) == 32);
	$can_overrule = (($group['user_permissions'] & 64) == 64);
	
	$template->assign('can_view', $can_view);
	$template->assign('can_edit', $can_edit);
	$template->assign('can_create', $can_create);
	$template->assign('can_redirect', $can_redirect);
	$template->assign('can_protect', $can_protect);
	$template->assign('can_delete', $can_delete);
	$template->assign('can_overrule', $can_overrule);
	
	$template->assign('GROUP', $group);
	$template->assign('LANGEDIT', $lang['can_edit']);
	$template->assign('LANGVIEW', $lang['can_view']);
	$template->assign('LANGREDIRECT', $lang['can_redirect']);
	$template->assign('LANGCREATE', $lang['can_create']);
	$template->assign('LANGPROTECT', $lang['can_protect']);
	$template->assign('LANGDELETE', $lang['can_delete']);
	$template->assign('LANGOVERRULE', $lang['can_overrule']);
	$template->assign('action', 'change');
	break;

case 'select':
	$database->query('SELECT `user_rank`, `group_name` FROM `permissions` WHERE `is_indiv_user` = 0');

	while ($result = $database->fetch_assoc($database->result))
	{
		$group_array[] = $result;
	}

	$template->assign('groups', $group_array);
	$template->assign('action', 'select');
	$template->assign('LANGSELECTGROUP', $lang['select_group']);
	$template->assign('formaction', 'change');
	break;

case 'set';
	$group = $_GET['group'];
	$permissions = $_GET['permissions'];
	$total = 0;

	for($i = 0; $i < count($permissions); $i++)
	{
		$total = $total + intval($permissions[$i]);
	}

	$database->query("UPDATE `permissions` SET `user_permissions` = '$total' WHERE `user_rank` = '$group'");
	header('Location: permissions.php');
	break;
}

pagetime($stimer, &$template, &$database);
$template->display('permissions.tpl');
?>