<?php
/***************************
*    COPYRIGHT NOTICE
* This software is produced by
* Alex Reinhart and is licenced 
* under the GNU General Public License. 
* There is no warranty whatsoever,
* and the creators are not responsible
* for damages to your system caused
* by this product.
* A copy of the General Public License
* is included in every download of this
* software, as LICENCE.txt. If you did 
* not receive a copy of the licence, 
* you may find it online.
***************************/

require_once "{$pathdot}/includes/config.php";
require_once "{$pathdot}/includes/$dbtype.php";

$stimer = explode( ' ', microtime() ); //page generation timer starts.
$stimer = $stimer[1] + $stimer[0];

$database = new Connection;
$database->connect($dbname, $dbserver, $dbuser, $dbpass);
unset($dbname);
unset($dbserver);
unset($dbuser);
unset($dbpass);
if ($config_use_file === FALSE)
{
	$database->query('SELECT * FROM `config`');
	while ($row = $database->fetch_assoc($database->result)) //got this from phpBB 3... don't tell them. :-p
	{
		$config[$row['field_name']] = $row['field_value'];
	}
	unset($row);
}

require_once "{$pathdot}/includes/lang_{$config['site_language']}/main.php";

//set Smarty settings according to config table
function templatesetup($template)
{
	global $config;
	if ($config['cache_on'] == 'true')
	{
		$cache = 1;

	}
	else
	{
		$cache = 0;
	}
	
	$template->compile_check = ($config['cache_check_comp'] == 'true');
	$template->caching = $cache;
	$template->cache_lifetime = intval($config['cache_lifetime']);
	$template->cache_dir = "./templates/{$config['template']}/cache";
}

function pagetime($stimer, $template, $database) //finish up the page exec timer
{
	$etimer = explode(' ', microtime());
	$etimer = $etimer[1] + $etimer[0];
	$template->assign('PAGETIME', round($etimer-$stimer, 3));
	$template->assign('QUERIES', $database->querycount);
	mysql_close();
}

function get_categories($database)
{
	$database->query('SELECT * FROM `categories` ORDER BY parent_id ASC, category_id ASC'); // Make sure to select parent_id
	$return_array = array();
	while ($result = $database->fetch_assoc($database->result))
	{
		$return_array[] = $result;
	}
	return $return_array;
}

/* Thanks to Aeternus for giving me this code, and Klaynos for helping me tweak it to what I needed */
function subcategorise (&$catArray, $currentCategories, $parentId = -1, $start = 0, $tab = '')
{
	/* Init */
	static $arrayCount = -1; /* Save us counting again each time or using global vars */
	static $indexArray = array();
	$i = $start;
	$category_set = '';
	/* Check for count */
	if ( $arrayCount < 0 )
	{
		$arrayCount = count ($catArray);
	}

	while ((($i < $arrayCount) && $catArray[$i]['parent_id'] <= $parentId))
	{
		/* Indexing */
		if ( ($i > $start) && ($catArray[$i-1]['parent_id'] != $catArray[$i]['parent_id']) )
		{
			/* Check that the index doesnt already exist */
			$index = $catArray[$i]['parent_id'];
			if (!isset($indexArray[ $index ]))
			{
				$indexArray[$index] = $i;
			}
		}
		/* Check for correct parent Id */
		if ( $catArray[$i]['parent_id'] == $parentId )
		{
                        /* Check for current categories */
		        if ( ($catIndex = array_search($catArray[$i]['category_id'], $currentCategories)) !== FALSE) {
		                $selected = ' selected="1"';
	                     	array_splice($currentCategories, $catIndex,1);
                        } else {
                                $selected = '';
                        }
			$category_set .= '<option value="' . $catArray[$i]['category_id'] . '"' . $selected . '>' . $tab . $catArray[$i]['category_title'] . '</option>';
			/* Check for possibility of children (this would be better served with a tinyint/bool
			  "has_children" column */
			if ($catArray[$i]['category_id'] <= $catArray[$arrayCount-1]['parent_id'])
			{
				/* Check for Index */
				if (isset($indexArray[ $catArray[$i]['category_id'] ] ) )
				{
					$subStart = $indexArray[ $catArray[$i]['category_id'] ];
				}
				else
				{
					$subStart = $i;
				}
				$category_set .= subcategorise ($catArray,$currentCategories, $catArray[$i]['category_id'], $subStart, $tab . '-');
			}
		}
		$i++;
	}
	return $category_set;
}

function setup_login_box($template, $user, $database, $lang, $config)
{
	if ($user->logincheck(&$database))
	{
		$template->assign('user_logged_in', TRUE);
		$template->assign('LOGINSTATUS', $lang['logged_in']);
		$template->assign('LANGLOGOUT', $lang['logout']);
		$template->assign('LOGINUSERNAME', stripslashes($user->user_name) . '.');
	}
	else
	{
		$template->assign('user_logged_in', FALSE);
		$template->assign('LANGUSERNAME', $lang['username']);
		$template->assign('LANGPASSWORD', $lang['password']);
		$template->assign('LANGREGISTER', $lang['register']);
	}
	
	if ($user->can_admin_panel === TRUE)
	{
		$template->assign('LANGADMINLINK', $lang['adminlink']);
		$template->assign('user_is_admin', TRUE);
	}
	else
	{
		$template->assign('user_is_admin', FALSE);
		$protect_notice = '';
		$protect_action = '';
	}
}

function setup_sidebar($lang, $template, $config, $user)
{
	global $protect_notice;
	global $protect_action;
	$template->assign('TEMPLATE', $config['template']);
	$template->assign('SITETITLE', $config['site_title']);
	$template->assign('LANGHOME', $lang['home']);
	$template->assign('LANGARTICLE', $lang['article']);
	$template->assign('LANGEDIT', $lang['edit']);
	$template->assign('LANGREDIRECT', $lang['redirect']);
	$template->assign('LANGPROTECT', $protect_notice);
	$template->assign('PROTECTACTION', $protect_action);
	$template->assign('LANGNEW', $lang['new']);
	$template->assign('LANGCOMMUNITY', $lang['community']);
	$template->assign('LANGSTATS', $lang['stats']);
	$template->assign('LANGHELP', $lang['help']);
	$template->assign('LANGSEARCH', $lang['search']);
	$template->assign('LANGHISTORY', $lang['history']);
	$template->assign('LANGRANDOM', $lang['random']);
	$template->assign('LANGTOOLS', $lang['tools']);
	$template->assign('LANGCATLIST', $lang['cat_list']);
	$template->assign('user_can_create', $user->can_create);
}

function parse($article_text) //parse BBCode (wikicode?)
{
	global $lang;
	$pre = array();
	$i = 0;
	while ($pre_str = stristr($article_text, "[nobb]")) //remove text inside [nobb] tags so it isn't parsed
	{
		$pre_str = substr($pre_str,0,strpos($pre_str,'[/nobb]')+7);
		$article_text = str_replace($pre_str, " ***pre_string***$i ", $article_text);
		// we encode this, for html tags, etc..
		$pre[$i] = htmlentities(str_replace("\r\n","\n",$pre_str));
		$i++;
	}
	unset($i);
	
	$escape_array = array("\""=>'&quot;', '--'=>'&mdash;', "'"=>'&#39;', '<'=>'&lt;', '>'=>'&gt;', "\n"=>"<br/>");
	$article_text = strtr($article_text, $escape_array); //escape the nasty stuff
	unset($escape_array);
	
	if (strstr($article_text, '[table]') != FALSE) //if they have a table, parse it
	{
		$table_array = array('[table]'=>'<table class=\'bbcode\'>', '[/table]'=>'</table>',
						     '[row]'=>'<tr>', '[/row]'=>'</tr>', '[tablehead]'=>'<th>', '[/tablehead]'=>'</th>', '[data]'=>'<td>', '[/data]'=>'</td>',
						     '[caption]'=>'<caption>', '[/caption]'=>'</caption>');
		$article_text = strtr($article_text, $table_array);
		unset($table_array);
	}

	if ((strstr($article_text, '[bullets]') != FALSE) or (strstr($article_text, '[list]') != FALSE)) //if they have lists, parse 'em
	{
		$list_array = array('[bullets]'=>'<ul>', '[*]'=>'<li>', '[/*]'=>'</li>', '[/bullets]'=>'</ul>',
							  '[list]'=>'<ol>', '[/list]'=>'</ol>');
		$article_text = strtr($article_text, $list_array);
		unset($list_array);
	}

	$article_text = preg_replace('/\[\[(.*?)\]\]/', '<a href="index.php?title=\\1" class="bodylink">\\1</a>', $article_text); //parse inside links
	//$article_text = preg_replace("#\[url=(?!\s*javascript:)([^\[]+)\]([^\[]+)\[/url\]#i","<a href=\"\\1\" target=\"_blank\" class=\"bodylink\">\\2</a>", $article_text);
	$article_text = preg_replace("/\[url=(?:http:\/\/)?([\/0-9a-zA-Z._-]+)\]([\D\S]+?)\[\/url\]/", "<a href=\"http://$1\" target=\"blank\" class=\"bodylink\">$2</a>", $article_text);
	$article_text = preg_replace("#\[url\](?!\s*javascript:)(?:http:\/\/)?([^\[]+)\[/url\]#i","<a href=\"http://$1\" target=\"_blank\" class=\"bodylink\">\\1</a>", $article_text);
	$article_text = preg_replace("#\[img\]([^\[]+)\[/img\]#i","<img src=\"\\1\" border=\"0\" alt=\"the image could not be loaded\" class=\"user\"/>", $article_text);
	$bbcode_array = array('[b]'=>'<strong>', '[/b]'=>'</strong>', '[i]'=>'<em>', '[/i]'=>'</em>',
						  '[u]'=>'<u>', '[/u]'=>'</u>', '[big]'=>'<big>', '[/big]'=>'</big>','[small]'=>'<small>',
						  '[/small]'=>'</small>', '[quote]'=>'<blockquote>', '[/quote]'=>'</blockquote>',
						  '[center]'=>'<center>', '[/center]'=>'</center>', '[code]'=>'<div class="legend">' . $lang['code'] . '</div><div class="code">',
						  '[/code]'=>'</div>', '[pre]'=>'<pre>', '[/pre]'=>'</pre>', '[right]'=>'<span class="right">', '[/right]'=>'</span>',
						  '[h]'=>'<span class="heading">', '[/h]'=>'</span>',
					  	  '[spoiler]'=>'<p><fieldset title="Hidden Spoiler - Highlight to read" class="spoiler"><legend>' . $lang['spoiler'] . '</legend><p class="spoiler">',
					  	  '[/spoiler]'=>'</p></fieldset></p>');
	$article_text = strtr($article_text, $bbcode_array); //parse the rest of the BBCode
	unset($bbcode_array);
	
	$cp = count($pre) - 1;
	for($i=0; $i <= $cp; $i++) //put back text in the [nobb] tags
	{
			$article_text = str_replace(" ***pre_string***$i ", substr($pre[$i], 6, -7), $article_text);
	}
	unset($i);
	unset($cp);
	unset($pre);
	return $article_text;
}

function escape($text)
{
	$escape_array = array("\'"=>'&quot;', '--'=>'&mdash;', "'"=>'&#39;', '<'=>'&lt;', '>'=>'&gt;');
	$text = strtr($text, $escape_array); //escape the nasty stuff
	unset($escape_array);
	return $text;
}

//Finally, user authentication and stuff
class User
{
	var $user_name;
	var $user_level;
	var $admin_perms;
	var $user_password;
	var $can_view;
	var $can_edit;
	var $can_redirect;
	var $can_protect;
	var $can_admin_panel;
	var $can_create;

	function login($database, $login_username, $login_password) //log them in
	{
		if (get_magic_quotes_gpc())
		{
			$login_username = stripslashes($login_username);
		}

		$password = md5($login_password);
		$login_username = mysql_real_escape_string($login_username);
				
		$database->query("SELECT users.user_id, users.user_password, users.user_admin_perms, permissions.user_permissions FROM `users` AS users, `permissions` AS permissions WHERE users.user_name = '{$login_username}' AND users.user_password = '{$password}' AND permissions.user_rank = users.user_level");
		
		if ($database->num_rows($database->result) != 1)
		{
			$database->query('SELECT user_permissions FROM `permissions` WHERE `user_rank` = 0');
			$result = $database->fetch_assoc($database->result);
			$this->user_level = $result['user_permissions'];
			$this->admin_perms = 0;
			$this->set_permissions();
			return FALSE;
		}
		else
		{
			$result = $database->fetch_assoc($database->result); //let's set all the session and user variables
			$this->user_name = $login_username;
			$this->user_password = $password;
			$this->user_level = $result['user_permissions'];
			$this->admin_perms = $result['user_admin_perms'];
			session_start();
			$_SESSION['user_id'] = $result['user_id'];
			$this->set_permissions();
			return TRUE;
		}
	}


	function logincheck($database) //make sure they're logged in and authorized
	{
		session_start();
		if (isset($_SESSION['user_id']))
		{
			$user_id = $_SESSION['user_id'];
			
			$database->query("SELECT users.user_name , users.user_admin_perms, permissions.user_permissions FROM `users` AS users, `permissions` AS permissions WHERE `user_id` ='{$user_id}' AND users.user_level = permissions.user_rank");
			
			if ($database->num_rows($database->result) != 1)
			{
				session_destroy(); //if there aren't any people with that userid, destroy session and quit.
				$this->admin_perms = 0;
				$this->set_permissions();
				return FALSE;
			}
			else
			{
				$result = $database->fetch_assoc($database->result); //if logincheck succeeds, set variables
				$this->user_name = $result['user_name'];
				$this->user_level = $result['user_permissions'];
				$this->admin_perms = $result['user_admin_perms'];
				$this->set_permissions();
				return TRUE;
			}
		}
		else
		{
			$database->query('SELECT user_permissions FROM `permissions` WHERE `user_rank` = 0');
			$result = $database->fetch_assoc($database->result);
			$this->user_level = $result['user_permissions']; //if the logincheck fails, set their userlevel to "guest"
			$this->user_name = 'Guest';
			$this->set_permissions();
			return FALSE;
		}
	}

	function logout() //log out
	{
		session_destroy(); //remove session and reset variables
	}

	function set_permissions()
	{
		$this->can_view = (($this->user_level & 1) == 1); //We use a binary permissions system -- add up these permissions and you 
		$this->can_edit = (($this->user_level & 2) == 2); //get a number that represents, say, admin permissions. We find if a certain
		$this->can_create = (($this->user_level & 4) == 4); // bit is set -- if the user has permissions of 00000011, the last 1 means
		$this->can_redirect = (($this->user_level & 8) == 8); //can_view and the first means can_edit. See?
		$this->can_protect = (($this->user_level & 16) == 16);
		$this->can_admin_panel = (($this->admin_perms & 1) == 1);
		$this->can_delete = (($this->user_level & 32) == 32);
		$this->can_overrule_protect = (($this->user_level & 64) == 64);
	}
}
?>