<?php
/***************************
*    COPYRIGHT NOTICE
* This software is produced by
* Alex Reinhart and is licenced 
* under the GNU General Public License. 
* There is no warranty whatsoever,
* and the creators are not responsible
* for damages to your system caused
* by this product.
* A copy of the General Public License
* is included in every download of this
* software, as LICENCE.txt. If you did 
* not receive a copy of the licence, 
* you may find it online.
***************************/

//Note to self: to reset Auto-Increment values, use "ALTER TABLE theTableInQuestion AUTO_INCREMENT=1234"

error_reporting(E_ALL); //I want to know if anything goes wrong. Remove in stable versions!

$title = isset($_GET['title']) ? $_GET['title'] : 'Index';
$action = isset($_GET['action']) ? $_GET['action'] : 'view';

$pathdot = '.';

require_once './includes/common.php'; //common functions be there
require_once './includes/Smarty.class.php'; //this is the templating engine file. I know, it's not my own. It's Smarty.
unset($pathdot);

$user = new User; //create a new User object. it's OOP so other modules can be added on.

$template = new Smarty(); //create a new Smarty object

templatesetup(&$template); //setup template with config stuff
setup_login_box(&$template, &$user, &$database, $lang, $config);


if (($action == 'view') || ($action == 'edit') || ($action == 'clearcache')) //figure out what the article title is if you're editing or viewing a page
{
	if (get_magic_quotes_gpc())
	{
		$title = stripslashes($title);
	}
	$database->query("SELECT * FROM articles WHERE article_title = '" . rawurlencode(stripslashes($title)) . "'");
	
	$article = $database->fetch_assoc($database->result);
	if ($article['article_protected'] == '1') //find out if the article is protected
	{
		$protect_notice = $lang['unprotectthis']; //what to do with the Protect This Page notice--if it's protected already, change to "Unprotect"
		$protect_action = 'unprotect';
		$template->assign('user_can_edit', FALSE);
	}
	else
	{
		$protect_notice = $lang['protectthis'];
		$protect_action = 'protect';
		$template->assign('user_can_edit', TRUE);
	}
}

else //if we're not viewing or editing, at least make sure the variables are defined so we don't get errors.
{
	$protect_notice = '';
	$protect_action = '';
	$article['article_title'] = 'Index';
	$template->assign('user_can_edit', FALSE);
}

//Now we assign all the variables for the header (title, toolbars...)
$template->assign('TITLE', stripslashes(rawurldecode($title)));
$template->assign('ATITLE', stripslashes($article['article_title']));
$template->assign('SITETITLE', $config['site_title']);
$template->assign('LANGHOME', $lang['home']);
$template->assign('LANGARTICLE', $lang['article']);
$template->assign('LANGEDIT', $lang['edit']);
$template->assign('LANGREDIRECT', $lang['redirect']);
$template->assign('TEMPLATE', $config['template']);
$template->assign('LANGPROTECT', $protect_notice);
$template->assign('PROTECTACTION', $protect_action);
$template->assign('LANGNEW', $lang['new']);
$template->assign('LANGCOMMUNITY', $lang['community']);
$template->assign('LANGSTATS', $lang['stats']);
$template->assign('LANGHELP', $lang['help']);
$template->assign('LANGSEARCH', $lang['search']);
$template->assign('LANGHISTORY', $lang['history']);
$template->assign('LANGRANDOM', $lang['random']);
$template->assign('LANGTOOLS', $lang['tools']);
$template->assign('LANGCATLIST', $lang['cat_list']);
$template->assign('user_can_protect', $user->can_protect);
$template->assign('user_can_create', $user->can_create);
$template->assign('user_can_delete', $user->can_delete);
$template->assign('LANGDELETE', $lang['delete_article']);
switch($action) //aha! Finally the real action. This checks what the 'action' variable is to see what we're supposed to be doing.
{
case 'clearcache':
	$template->clear_cache('view.tpl');

case 'view':
	if ($user->can_view === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}

	if (($config['cache_on'] == 'true') && ($template->is_cached('view.tpl') == TRUE))
	{
		$tplfile = 'view.tpl';
		die('cache on!');
		break;
	}
	
	$cache = $template->is_cached('view.tpl');
	
	if ($article['is_redirect'] == 1)
	{
		$database->query("SELECT `redirect_to` FROM `redirects` WHERE `redirect_from` = '{$title}' LIMIT 1"); //find if this page should be redirecting
		$redirects = $database->result; //access result in the database class

		if ($database->num_rows($redirects) == 1) //if this page ought to redirect, do that
		{
			$redirect = $database->fetch_assoc($redirects);
			header("Location: index.php?title={$redirect['redirect_to']}");
			die();
		}
	unset($redirects);
	}
	
	$is_subpage = strpos(rawurldecode($title), '/'); //check to see if it's a subpage of another page.

	if ($is_subpage != FALSE)
	{
		$otitle = $title;
		$title = substr(rawurldecode($title), ++$is_subpage);
		$template->assign('SUBTITLE', $lang['return'] . substr(rawurldecode($otitle), 0, --$is_subpage));
		$template->assign('TITLE', stripslashes($title));
		$template->assign('STITLE', substr(rawurldecode($otitle), 0, $is_subpage));
	}

	if ($article['article_text'] == NULL) //if the page is empty or doesn't exist...
	{
		header('Location: index.php?action=create&title=' . $title);
	}

	$template->assign('ARTICLETEXT', parse(stripslashes($article['article_text']))); //parse BBCode and set the variables.
	$template->assign('showhistory', TRUE);
	$tplfile = 'view.tpl';
	break;

case 'edit':
	if ($user->can_edit === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	
	if (($article['article_protected'] == '1') && ($user->can_overrule_protect === FALSE)) //if it's protected, don't let them in. give an error.
	{
		header('Location: error.php?error=protected');
	}
	
	$database->query("SELECT `category_id` FROM `article_categories` WHERE `article_id` = '{$article['article_id']}'");
	
	while ($result = $database->fetch_row($database->result))
	{
		$article_categories[] = $result[0];
	}

	if (!isset($article_categories))
	{
		$article_categories[] = '0';
	}
	
	$categories = subcategorise(get_categories(&$database), $article_categories);
	$template->assign('CUR_CATEGORIES', implode(',', $article_categories));
	unset($article_categories);
	
	$template->assign('CATEGORIES', $categories);
	unset($categories);
	
	$template->assign('LANGCATEGORIES', $lang['edit_categories']);
	$template->assign('TITLE', $lang['editing'] . ': ' . rawurldecode($article['article_title']));
	$template->assign('ARTICLETEXT', stripslashes($article['article_text']));
	$template->assign('LANGSAVE', $lang['savechanges']);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'edit.tpl';
	break;

case 'create':
	if ($user->can_create === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	
	$title = isset($_GET['title']) ? $_GET['title'] : $lang['article_title'];
	if ($title != $lang['article_title'])
	{
		$template->assign('MESSAGE', $lang['creating_empty']);
	}
	$article_categories[] = '0';
	$categories = subcategorise(get_categories(&$database), $article_categories);
	$template->assign('CATEGORIES', $categories);
	unset($categories);
	unset($article_categories);
	$template->assign('LANGCATEGORIES', $lang['edit_categories']);
	$template->assign('LANGARTICLETITLE', $title); //set variables for the creating page template. simple enough.
	$template->assign('LANGCREATEPAGE', $lang['create_page']);
	$template->assign('TITLE', $lang['create_page']);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'create.tpl';
	break;

case 'redirect':
	if ($user->can_redirect === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	$template->clear_cache('redirect.tpl');
	$template->assign('LANGCREATEREDIRECT', $lang['redirect']); //if they want to create a redirect.
	$template->assign('LANGREDIRECTFROM', $lang['redirect_from']);
	$template->assign('LANGREDIRECTTO', $lang['redirect_to']);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'redirect.tpl';
	break;

case 'statistics': // NOTE TO SELF: add more stats!
	if ($user->can_view === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	$database->query('SELECT MAX(article_id) FROM articles'); //find the number of articles by using the article id
	$article_num = $database->result;
	$article_num = $database->fetch_assoc($article_num);

	$database->query('SELECT MAX(redirect_id) FROM redirects'); //find number of redirects...
	$redirect_num = $database->result;
	$redirect_num = $database->fetch_assoc($redirect_num);
	if ($redirect_num['MAX(redirect_id)'] == '') //if no redirects...
	{
		$redirect_num['MAX(redir>ect_id)'] = '0';
	}

	$database->query('SELECT MAX(user_id) FROM users'); //get number of users
	$user_num = $database->result;
	$user_num = $database->fetch_assoc($user_num); //there'll always be 1 user, so no need to worry about what happens if there are 0

	$template->assign('TITLE', $lang['stats']);
	$template->assign('ARTICLETEXT', $lang['num_articles'] . ': ' . $article_num['MAX(article_id)'] . '<br/>' . $lang['num_redirects'] . ': ' . $redirect_num['MAX(redirect_id)'] . '<br/>' . $lang['num_users'] . ': ' . $user_num['MAX(user_id)']);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'view.tpl';
	break;

case 'protect':
	if ($user->can_protect === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	//$template->clear_cache('protect_this.tpl');
	$template->assign('LANGPROTECTTHIS', $lang['protectthis']); //protect this page.
	$template->assign('LANGPROTECTING', $lang['protecting']);
	$template->assign('LANGYES', $lang['yes']);
	$template->assign('LANGNO', $lang['no']);
	$template->assign('ACTION', 'protect');
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'protect_this.tpl';
	break;

case 'unprotect':
	if ($user->can_protect === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}

	$template->assign('LANGPROTECTTHIS', $lang['unprotectthis']); //unprotect a page.
	$template->assign('LANGPROTECTING', $lang['unprotecting']);
	$template->assign('LANGYES', $lang['yes']);
	$template->assign('LANGNO', $lang['no']);
	$template->assign('ACTION', 'unprotect');
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'protect_this.tpl';
	break;

case 'history':
	if ($user->can_view === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	
	$start = isset($_GET['start']) ? $_GET['start'] : '0';
	$database->query("SELECT `article_revision_no`, `article_editor`, `edit_time` FROM `old_articles` WHERE `article_title` = '{$title}' ORDER BY `article_revision_no` DESC LIMIT {$start}, 50");
	$edit_array = array();
	$i = 0;
	while (($i < 50) && ($result = $database->fetch_assoc($database->result)))
	{
		$edit_array[] = $result;
		$i++;
	}

	$arraylength = count($edit_array);
	for ($i = 0; $i< $arraylength; $i++)
	{
		$edit_array[$i]['edit_time'] = date($config['datetime'], $edit_array[$i]['edit_time']);
	}
	unset($arraylength);
	unset($i);
	
	$template->assign('ATITLE', rawurldecode($title));
	$template->assign('HISTORY', $edit_array);
	unset($edit_array);
	$template->assign('LANGUSER', $lang['editor']);
	$template->assign('LANGNUM', $lang['edit_num']);
	$template->assign('LANGTIME', $lang['time']);
	$template->assign('LANGREVERT', $lang['revert']);
	$template->assign('LANGNEXT', $lang['next_page']);
	$template->assign('START', $start + 50);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'history.tpl';
	break;

case 'random':
	if ($user->can_view === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	$database->query('SELECT `article_id` FROM `articles`');
	$num_articles =	$database->num_rows($database->result);
	$random = rand(1, $num_articles);
	$database->query("SELECT `article_title` FROM `articles` WHERE `article_id` = '{$random}'");
	$title = $database->fetch_assoc($database->result);
	header("Location: index.php?title={$title['article_title']}");
	break;
	
case 'catlist':
	if ($user->can_view === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	$parent_id = isset($_GET['pid']) ? $_GET['pid'] : '-1';
	
	$database->query("SELECT * FROM `categories` WHERE `parent_id` = '{$parent_id}' ORDER BY parent_id ASC, category_id ASC"); // Make sure to select parent_id
	$category_array = array();
	$i = 0;
	while ($result = $database->fetch_assoc($database->result))
	{
		$category_array[$i]['category_title'] = $result['category_title'];
		$category_array[$i]['category_id'] = $result['category_id'];
		$i++;
	}
	
	$template->assign('cat_list', $category_array);
	if (count($category_array) != 0)
	{
		$template->assign('LANGCATEGORIES', $lang['categories']);
	}
	else
	{
		$template->assign('LANGCATEGORIES', $lang['no_categories']);
	}
	unset($category_array);
	
	$database->query("SELECT `article_id`, `article_title` FROM `article_categories` WHERE `category_id` = '{$parent_id}'");
	$i = 0;
	while ($result = $database->fetch_assoc($database->result))
	{
		$article_array[$i]['article_title'] = stripslashes(rawurldecode($result['article_title']));
		$article_array[$i]['article_id'] = $result['article_id'];
		$i++;
	}
	if (isset($article_array) && get_magic_quotes_gpc())
	{
		for($i = 0; $i < count($article_array); $i++)
		{
			$article_array[$i]['article_title'] = stripslashes($article_array[$i]['article_title']);
		}
	}
	unset($i);
	if (isset($article_array))
	{
		$template->assign('has_articles', TRUE);
		$template->assign('article_list', $article_array);
		$template->assign('LANGARTICLES', $lang['cat_articles']);
	}
	else
	{
		$template->assign('has_articles', FALSE);
		$template->assign('LANGNOARTICLES', $lang['cat_no_articles']);
	}
	unset($article_array);
	$template->assign('user_can_delete', FALSE);
	$tplfile = 'catlist.tpl';
	break;
	
case 'register':
	$template->assign('USERNAME', $lang['username']);
	$template->assign('PASSWORD', $lang['password']);
	$template->assign('CONFIRM', $lang['confirm_password']);
	$template->assign('REGISTER', $lang['register']);
	$template->assign('EMAIL', $lang['email']);
	$tplfile = 'register.tpl';
	break;
	
case 'delete':
	if ($user->can_delete === FALSE)
	{
		header('Location: error.php?error=permissions');
		die();
	}
	$template->assign('LANGPROTECTING', $lang['confirm_delete']);
	$template->assign('LANGPROTECTTHIS', $lang['deleting']);
	$template->assign('LANGYES', $lang['yes']);
	$template->assign('LANGNO', $lang['no']);
	$template->assign('ACTION', 'delete');
	$tplfile = 'protect_this.tpl';
	break;

default:
 	die('<p> The action selected does not exist.</p>'); //if they did action=djkfajldj or something like that, throw an error. Could be hack attempt.

}
unset($action);

pagetime($stimer, &$template, $database);
unset($lang);
$template->display($tplfile);

// cwKZh-C/OAWv-AAAQY-AnIT+Q-AAEN
?>