<?php
/**
* Function to grab all categories into an array.
*
* Function is here so that method of sorting
* and acquiring data can be changed easily later.
*
* @param Object ($db) - Database Object - Might want to look into the singleton class pattern
* @return Array - List of Categories.
*/

error_reporting(E_ALL);

$pathdot = '.';
include './includes/common.php';
function get_categories($database)
{
	$database->query('SELECT * FROM `categories` ORDER BY parent_id ASC, category_id ASC'); // Make sure to select parent_id
	//return $db->getArray(); /*/getRows/resultSet/whatever */
	$returnArray = array();
	while ($result = $database->fetch_assoc($database->result))
	{
	$returnArray[] = $result;
	}
	return $returnArray;
}

/**
* Function to display the categories and
* subcategories. This could simply format
* them into a multidimensional array structure
* or some other format so as not to do any
* formatting in the main code (keeping to the
* smarty philosophy) but this would require
* another recursive function set on the template
* side or some clever thinking.
*
* @param Integer ($parentId) - Parent category to display (Default - -1)
* @param Integer ($start) - Where in the array to start (Default - 0)
* @param String ($tab) - Prepended with additional space character to tab
*						 subcategories across.
*/
function subcategorise (&$catArray, $parentId = -1, $start = 0, $tab = '')
{
	/* Init */
	static $arrayCount = -1; /* Save us counting again each time or using global vars */
	static $indexArray = array();
	$i = $start;
	/* Check for count */
	if ( $arrayCount < 0 )
	{
		$arrayCount = count ($catArray);
	}

	while ((($i < $arrayCount) && $catArray[$i]['parent_id'] <= $parentId))
	{
		/* Indexing */
		if ( ($i > $start) && ($catArray[$i-1]['parent_id'] != $catArray[$i]['parent_id']) )
		{
			/* Check that the index doesnt already exist */
			$index = $catArray[$i]['parent_id'];
			if (!isset($indexArray[ $index ]))
			{
				$indexArray[$index] = $i;
			}
		}
		/* Check for correct parent Id */
		if ( $catArray[$i]['parent_id'] == $parentId )
		{
			echo '<option value="' . $catArray[$i]['category_id'] . '">' . $tab . $catArray[$i]['category_title'] . '</option>';
			/* Check for possibility of children (this would be better served with a tinyint/bool
			   "has_children" column */
			if ($catArray[$i]['category_id'] <= $catArray[$arrayCount-1]['parent_id'])
			{
				/* Check for Index */
				if (isset($indexArray[ $catArray[$i]['category_id'] ] ) )
				{
					$subStart = $indexArray[ $catArray[$i]['category_id'] ];
				}
				else
				{
					$subStart = $i;
				}
				subcategorise ($catArray, $catArray[$i]['category_id'], $subStart, $tab . '-');
			}
		}
		$i++;
	}
}

echo '<select name="categories[]" multiple="multiple">';
subcategorise(get_categories($database));
echo '</select>';
$etimer = explode(' ', microtime());
$etimer = $etimer[1] + $etimer[0];
print round($etimer-$stimer, 4);

?>